
variables {
  CanMessage   txmsg;
  CanMessage   txmsg_echo;
  timer txTimer;
  int counter;
  int brs_enabled;
  int fdf_enabled;
}


on start {
  printf ("*** CANFD Test started ***\n");
  counter = 0;
  txTimer.timeout = 100;
  timerStart (txTimer);

  fdf_enabled = 0;
  brs_enabled = 0;
}


on action "Start Sending" {
  printf ("Start sending\n");
  timerStart (txTimer);
}


on action "Stop Sending" {
  printf ("Stop sending\n");
  timerCancel (txTimer);
}


on action "Toggle BRS" {
  brs_enabled = !brs_enabled;
  printf ("BRS: ");
  if (brs_enabled) printf ("ON");
              else printf ("OFF");
  printf ("\n");
}

              // ALT
              on action "Toggle EDL" {
                fdf_enabled = !fdf_enabled;
                printf ("EDS: ");
                if (fdf_enabled) printf ("ON");
                            else printf ("OFF");
                printf ("\n");
              }


on action "Toggle FDF" {
  fdf_enabled = !fdf_enabled;
  printf ("FDF: ");
  if (fdf_enabled) printf ("ON");
              else printf ("OFF");
  printf ("\n");
}


on stopped {
  printf ("*** Stopped ***\n");
}


on message Ramp { // Send Echo
  int r = 0;
  int is_canfd = 0;

  txmsg_echo.id = 50;

  txmsg_echo.flags = 0;
  txmsg_echo.dlc =  8; // default: standard length

  txmsg_echo.data [0] = this.data [7]; // echo channel number
  txmsg_echo.data [1] = 0x00; // echo channel number
  txmsg_echo.data [2] = this.data [4]; // echo counter
  txmsg_echo.data [3] = this.data [5]; // echo counter

  //if (this.data [7] & 0x80) is_canfd = 1;
  if (this.flags & CANMSG_FLAG_FDF) is_canfd = 1;
  if (this.flags & CANMSG_FLAG_BRS) is_canfd = 1;

  //printf ("flags=%08x id=%d\n", this.flags, this.id);

  //if (this.flags & (CANMSG_FLAG_FDF | CANMSG_FLAG_BRS)) {
  if (is_canfd) {
    txmsg_echo.flags |= CANMSG_FLAG_FDF; /* enable CANFD */
    txmsg_echo.flags |= CANMSG_FLAG_BRS; /* enable CANFD */
    txmsg.dlc = 32;
  }

  r = canSendMessage (txmsg_echo);
  if (r != 0) {
    printf ("SEND FAILED!!!\n");
    canReset ();
  }
} // on message Ramp


on timer txTimer {
  int i = 0;

  timerStart (txTimer);

  txmsg.id = 0x100;

  txmsg.flags = 0;
  txmsg.dlc =  8; // default: standard length

  if (fdf_enabled) {
    txmsg.flags |= CANMSG_FLAG_FDF; /* enable CANFD */
    txmsg.dlc = 64;

    if (brs_enabled) txmsg.flags |= CANMSG_FLAG_BRS;
  }

  // fill in default data
  for (i = 0; i < txmsg.dlc; ++i) {
    txmsg.data [i] = i;
  }

txmsg.id = 0x555;
counter = 0x5555;

  txmsg.data [0] = counter >> 8;
  txmsg.data [1] = counter;
  txmsg.data [2] = 0x00;
  txmsg.data [3] = 0x00;

txmsg.dlc = 2;

  canSendMessage (txmsg);

  counter += 1;
}


