
variables {
  int counter;
  int dac_value1;
  int dac_value1_inc;
  int dac_value2;
  int dac_value2_inc;

  timer CyclicSend;
  timer dacSetTimer;
}

/***************************************************************************/

on start  {
  counter = 0;
  dac_value1 = 0;
  dac_value2 = 0;
  dac_value1_inc = 50;
  dac_value2_inc = 25;

  printf ("STARTED %d\n", counter);
  CyclicSend.timeout = 1000;
  dacSetTimer.timeout = 1;
  timerStart (CyclicSend);
  timerStart (dacSetTimer);
}


on stopped  {
  printf ("STOPPED\n");
}


on timer dacSetTimer {
  timerStart (dacSetTimer);

  ioSetOutput (IO_DAC1, dac_value1);
  ioSetOutput (IO_DAC2, dac_value2);

  dac_value1 += dac_value1_inc;
  if (dac_value1 > 65535) dac_value1 = 0;

  dac_value2 += dac_value2_inc;
  if (dac_value2 > 65535) {
    dac_value2 = 65535;
    dac_value2_inc = -dac_value2_inc;
  }
  else if (dac_value2 < 0) {
    dac_value2 = 0;
    dac_value2_inc = -dac_value2_inc;
  }
  //printf ("dac_value1=%d\n", dac_value1);
  //printf ("dac_value2=%d\n", dac_value2);
}


on timer CyclicSend {
  int c2;

  timerStart (CyclicSend);

  if (CyclicSend.timeout == 1000) {
    printf ("counter=%d IN1=%d IN2=%d ADC1=%d ADC2=%d ADC3=%d\n",
             counter,
             ioGetInput (IO_IN1),
             ioGetInput (IO_IN2),

             ioGetInput (IO_ADC1),
             ioGetInput (IO_ADC2),
             ioGetInput (IO_ADC3) );
  }

  counter++;

  c2 = counter & 0x3;

  if (counter & 1) ioSetOutput (IO_OUT1, 1);
              else ioSetOutput (IO_OUT1, 0);


  //if (counter & 2) ioSetOutput (IO_OUT2, 1);
  if (c2 == 0) ioSetOutput (IO_OUT2, 1);
          else ioSetOutput (IO_OUT2, 0);

  /* LEDs */
  if (c2 == 0) ioSetOutput (IO_LED1, 1);
          else ioSetOutput (IO_LED1, 0);

  if (c2 == 1) ioSetOutput (IO_LED2, 1);
          else ioSetOutput (IO_LED2, 0);

  if (c2 == 2) ioSetOutput (IO_LED3, 1);
          else ioSetOutput (IO_LED3, 0);

  if (c2 == 3) ioSetOutput (IO_LED4, 1);
          else ioSetOutput (IO_LED4, 0);
}


on key ' ' {
  printf ("SPACE %x\n", this);
}


on key 'a' {
  printf ("A %d\n", this);
}


on key 'h' {
  if (CyclicSend.timeout == 1) CyclicSend.timeout = 1000;
                          else CyclicSend.timeout = 1;

  printf ("new timeout=%d\n", CyclicSend.timeout);
}


on key 'e' {
  printf ("Endless loop=%d\n");
  while (1) {
  }
}


/***************************************************************************/

